--- old/usr/src/uts/common/fs/zfs/spa.c	Mon Aug  5 21:59:08 2013
+++ new/usr/src/uts/common/fs/zfs/spa.c	Mon Aug  5 21:59:08 2013
@@ -1479,8 +1479,21 @@
 
 			(void) vdev_validate_aux(vd);
 
-			if (!vdev_is_dead(vd))
-				l2arc_add_vdev(spa, vd);
+			if (!vdev_is_dead(vd)) {
+				boolean_t persist = B_FALSE;
+
+				if (spa->spa_load_state != SPA_LOAD_TRYIMPORT) {
+					/*
+					 * Only allow to do the L2ARC rebuild
+					 * when not doing a spa try-load.
+					 */
+					(void) nvlist_lookup_boolean_value(
+					    l2cache[i],
+					    ZPOOL_CONFIG_L2CACHE_PERSISTENT,
+					    &persist);
+				}
+				l2arc_add_vdev(spa, vd, persist);
+			}
 		}
 	}
 
@@ -3880,11 +3893,6 @@
 		spa->spa_spares.sav_config = NULL;
 		spa_load_spares(spa);
 	}
-	if (spa->spa_l2cache.sav_config) {
-		nvlist_free(spa->spa_l2cache.sav_config);
-		spa->spa_l2cache.sav_config = NULL;
-		spa_load_l2cache(spa);
-	}
 
 	VERIFY(nvlist_lookup_nvlist(config, ZPOOL_CONFIG_VDEV_TREE,
 	    &nvroot) == 0);
